c
c ---------------------------------------------------------------
c
      subroutine ff1(card,xlat,xlon)
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
c - Subroutine to take one "Free Format, Type 1"
c - record (card) and extract the latitude and 
c - longitude (xlat,xlon) in decimal degrees
ccccccccccccccccccccccccccccccccccccccccccccccccccc
      character*80 SCCSID
      character*80 card
      character*40 ecard

      integer*4 b(50),e(50)
      integer*4 bkt
      integer*4 ekt
      integer*4 ival
      integer*4 iflag

      real*8    xlat,xlon 
      real*8    deglat,minlat,seclat
      real*8    deglon,minlon,seclon
      real*8    xval

      integer   ii
      integer   ilen 
      integer   lnblnk

      SCCSID="@(#)ff1.f   	1.1	2004/01/16 NGS"


      bkt = 0
      ekt = 0
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
c - Search for the beginnings
c - and endings of numbers, assuming only
c - that we'll find the numbers '0' through '9' as
c - well as spaces, ' ', and decimals '.', and
c - perhaps a leading negative sign.
c - 
c - Comma delimeted data will not work
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
      ecard = card(41:80)

      ilen = lnblnk(ecard)
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
c - The position of the character which begins
c - the first 'number' is b(1), and the position
c - of the character which ends the first 'number'
c - is e(1).....etc for all numbers.  (Positions
c - are counted, in Free Format Type 1, as counting
c - 1 to 40(at most), starting in the 41st character 
c - of the record.)
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
      if(ecard(1:1).ne.' ')then
        bkt = bkt + 1
        b(bkt) = 1
      endif
 
      do 1 ii=2,ilen
        if(ecard(ii:ii).eq.' ')then
          if(ecard(ii-1:ii-1).ne.' ')then
            ekt = ekt + 1
            e(ekt) = ii-1
          endif
        else
          if(ecard(ii-1:ii-1).eq.' ')then
            bkt = bkt + 1
            b(bkt) = ii
          endif
        endif
    1 continue

c - Count the last space as an end, since we've
c - already defined its length as the last
c - non-space character
      ekt = ekt + 1
      e(ekt) = ii-1

ccccccccccccccccccccccccccccccccccccccccccccccccccc 
c - Obviously the number of beginnings and 
c - endings must be the same.
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
      if(bkt .ne. ekt)stop 80808

ccccccccccccccccccccccccccccccccccccccccccccccccccc 
c - Integer/Decimal Degrees (2 numbers)
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
      if(bkt .eq. 2)then
c - The following line doesn't work with older FORTRAN compilers
c       read(ecard,*)deglat,deglon

        call val(ecard(b(1):e(1)),iflag,ival,xval)
        if(iflag.eq.0)deglat = ival
        if(iflag.eq.1)deglat = xval

        call val(ecard(b(2):e(2)),iflag,ival,xval)
        if(iflag.eq.0)deglon = ival
        if(iflag.eq.1)deglon = xval

        xlat = deglat
        xlon = deglon

ccccccccccccccccccccccccccccccccccccccccccccccccccc 
c - Integer Degrees & Integer/Decimal 
c - minutes (4 numbers)
c - Take care with pos/neg signs
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
      elseif(bkt .eq. 4)then
c - The following line doesn't work with older FORTRAN compilers
c       read(ecard,*)deglat,minlat,deglon,minlon

        call val(ecard(b(1):e(1)),iflag,ival,xval)
        if(iflag.eq.0)deglat = ival
        if(iflag.eq.1)deglat = xval

        call val(ecard(b(2):e(2)),iflag,ival,xval)
        if(iflag.eq.0)minlat = ival
        if(iflag.eq.1)minlat = xval
        if(deglat.lt.0)minlat = -minlat

        call val(ecard(b(3):e(3)),iflag,ival,xval)
        if(iflag.eq.0)deglon = ival
        if(iflag.eq.1)deglon = xval

        call val(ecard(b(4):e(4)),iflag,ival,xval)
        if(iflag.eq.0)minlon = ival
        if(iflag.eq.1)minlon = xval
        if(deglon.lt.0)minlon = -minlon

        xlat = deglat+(minlat/60.d0)
        xlon = deglon+(minlon/60.d0)

ccccccccccccccccccccccccccccccccccccccccccccccccccc 
c - Integer Degrees, Integer Minutes & 
c - Integer/Decimal Seconds (6 numbers)
c - Take care with pos/neg signs
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
      elseif(bkt .eq. 6)then
c - The following line doesn't work with older FORTRAN compilers
c       read(ecard,*)deglat,minlat,seclat,
c    *               deglon,minlon,seclon

        call val(ecard(b(1):e(1)),iflag,ival,xval)
        if(iflag.eq.0)deglat = ival
        if(iflag.eq.1)deglat = xval

        call val(ecard(b(2):e(2)),iflag,ival,xval)
        if(iflag.eq.0)minlat = ival
        if(iflag.eq.1)minlat = xval
        if(deglat.lt.0)minlat = -minlat

        call val(ecard(b(3):e(3)),iflag,ival,xval)
        if(iflag.eq.0)seclat = ival
        if(iflag.eq.1)seclat = xval
        if(deglat.lt.0)seclat = -seclat

        call val(ecard(b(4):e(4)),iflag,ival,xval)
        if(iflag.eq.0)deglon = ival
        if(iflag.eq.1)deglon = xval

        call val(ecard(b(5):e(5)),iflag,ival,xval)
        if(iflag.eq.0)minlon = ival
        if(iflag.eq.1)minlon = xval
        if(deglon.lt.0)minlon = -minlon

        call val(ecard(b(6):e(6)),iflag,ival,xval)
        if(iflag.eq.0)seclon = ival
        if(iflag.eq.1)seclon = xval
        if(deglon.lt.0)seclon = -seclon

        xlat = deglat+(minlat/60.d0)+(seclat/3600.d0)
        xlon = deglon+(minlon/60.d0)+(seclon/3600.d0)

ccccccccccccccccccccccccccccccccccccccccccccccccccc       
c - Otherwise there's an error and the lat/lon 
c - are set to -999
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
      else
        xlat = -999.d0
        xlon = -999.d0
      endif

ccccccccccccccccccccccccccccccccccccccccccccccccccc       
c - If, somehow, the lat value isn't in the
c - right range, turn both lat/lon into -999s.
c - If, somehow, the lon value isn't in the
c - right range, try some simple arithmetic
c - and if that fails, turn both lat/lon into
c - -999s
ccccccccccccccccccccccccccccccccccccccccccccccccccc 
      if(xlon.lt.000)xlon = xlon + 360.d0
      if(xlon.gt.360)xlon = xlon - 360.d0

      if(xlat.lt.-90 .or. xlat.gt.+90 .or.
     *   xlon.lt.000 .or. xlon.gt.360)then
        xlat = -999.d0
        xlon = -999.d0
      endif

      return
      end
c
