C /ngslib/source/Geoid/Flib/SCCS/s.initsp.f

      subroutine initsp (YY, NN, RR, QQ)
********************************************************************************
* INITIALIZATION PROCEDURE FOR FAST 1-DIMENSIONAL EQUIDISTANT
* SPLINE INTERPOLATION, WITH FREE BOUNDARY END CONDITIONS
* REFERENCE: JOSEF STOER: EINFUHRUNG IN DIE NUMERISCHE MATHEMATIK
* I, SPRINGER 1972, PAGE 82 AND 86.
*    in - YY : GIVEN VALUES, Y(1), ..., Y(NN)
* 
*    out- RR : SPLINE MOMENTS (1 ... NN), TO BE USED BY FUNCTION 'SPLINE'
* 
*    in - QQ : WORK-ARRAY, DECLARED AT LEAST 1:NN
* --------------------------------------------------------------------
*  1983 Jul    Original by RENE FORSBERG
*  2007 May    Modified at NGS
* --------------------------------------------------------------------
********************************************************************************
      implicit none
      character*99 SCCSID
      real*8  YY
      real*8  RR
      real*8  QQ
      integer NN

      real*8  P
      integer K

      DIMENSION YY(NN), RR(NN), QQ(NN)

      SCCSID="@(#)initsp.f	1.1	2008/04/23 NGS"
      QQ(1) = 0.0
      RR(1) = 0.0

      DO K = 2, NN-1
        P     = QQ(K-1)/2 + 2
        QQ(K) = -0.5/P
        RR(K) = (3* (YY(K+1) - 2*YY(K) + YY(K-1)) - RR(K-1)/2)/P
      enddo

      RR(NN) = 0.0
      DO K = NN-1, 2, -1
        RR(K) = QQ(K)*RR(K+1) + RR(K)
      enddo
      RETURN
      END

